local WM = WINDOW_MANAGER

function GroupDamage:InitializeControls()

	--Main control container (panel header)
	self.control = WM:GetControlByName("GroupDamageControl")
	self.control:ClearAnchors()
	self.control:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, self.svars.offset["x"], self.svars.offset["y"])
	self.control:SetScale(1)  
	self.control.bg = WM:CreateControlFromVirtual("$(parent)HeaderBg", self.control, "GDBackdropFill")
	self.control.bg:SetCenterColor(self.svars.panelHeaderColor[1], self.svars.panelHeaderColor[2], self.svars.panelHeaderColor[3], self.svars.panelHeaderColor[4])
	self.control.title = WM:CreateControlFromVirtual("$(parent)Title", self.control, "GDLabel18b")
	self.control.title:SetAnchor(LEFT, self.control, LEFT, 3, 0)

	--Unit bars container 
	self.control.barArea = WM:CreateControl("$(parent)BarArea", self.control, CT_CONTROL)
	self.control.barArea:SetAnchor(TOPLEFT, self.control, BOTTOMLEFT, 0, 0)
	self.control.barArea:SetAnchor(TOPRIGHT, self.control, BOTTOMRIGHT, 0, 0)
	self.control.barArea.bars = {}	
	for i=1,12 do
		self.control.barArea.bars[i] = WM:CreateControl("$(parent)Bar"..i, self.control.barArea, CT_CONTROL)
		self.control.barArea.bars[i]:SetAnchor(TOP, self.control.barArea.bars[i-1], BOTTOM, 0, 0)
		if i == 1 then
			self.control.barArea.bars[1]:ClearAnchors()
			self.control.barArea.bars[1]:SetAnchor(TOP, self.control.barArea, TOP, 0, 0)					
		end
		self.control.barArea.bars[i]:SetWidth(300)
		self.control.barArea.bars[i]:SetHeight(20)
		self.control.barArea.bars[i].statusBar = WM:CreateControlFromVirtual("$(parent)StatusBar", self.control.barArea.bars[i], "GDPlayerBar") 		
		self.control.barArea.bars[i].bg = WM:CreateControlFromVirtual("$(parent)Bg", self.control.barArea.bars[i], "GDBackdropFill")			
		self.control.barArea.bars[i].name = WM:CreateControlFromVirtual("$(parent)Name", self.control.barArea.bars[i], "GDLabel16")
		self.control.barArea.bars[i].name:SetAnchor(LEFT, self.control.barArea.bars[i], LEFT, 2, -1)		
		self.control.barArea.bars[i].value = WM:CreateControlFromVirtual("$(parent)Value", self.control.barArea.bars[i], "GDLabel16")
		self.control.barArea.bars[i].value:SetAnchor(RIGHT, self.control.barArea.bars[i], RIGHT, -2, -1)
	end
	
	--Info area container
	self.control.infoArea = WM:CreateControl("$(parent)InfoArea", self.control, CT_CONTROL)
	self.control.infoArea:SetAnchor(TOPLEFT, self.control.barArea, BOTTOMLEFT, 0, 0)
	self.control.infoArea:SetAnchor(TOPRIGHT, self.control.barArea, BOTTOMRIGHT, 0, 0)
	self.control.infoArea:SetHeight(40)
	self.control.infoArea.bg = CreateControlFromVirtual("$(parent)Bg", self.control.infoArea, "GDBackdropFill")
	self.control.infoArea.bg:SetCenterColor(self.svars.panelHeaderColor[1], self.svars.panelHeaderColor[2], self.svars.panelHeaderColor[3], self.svars.panelHeaderColor[4])
	self.control.infoArea.combatInfo = WM:CreateControlFromVirtual("$(parent)CombatInfo", self.control.infoArea, "GDLabel15")
	self.control.infoArea.combatInfo:SetAnchor(TOPLEFT, self.control.infoArea, TOPLEFT, 2, 0)
	self.control.infoArea.combatTarget = WM:CreateControlFromVirtual("$(parent)CombatTarget", self.control.infoArea, "GDLabel15")
	self.control.infoArea.combatTarget:SetAnchor(BOTTOMLEFT, self.control.infoArea, BOTTOMLEFT, 2, 0)
	self.control.infoArea.combatDmg = WM:CreateControlFromVirtual("$(parent)CombatDmg", self.control.infoArea, "GDLabel15")
	self.control.infoArea.combatDmg:SetAnchor(TOPRIGHT, self.control.infoArea, TOPRIGHT, -2, 0)
	self.control.infoArea.combatDps = WM:CreateControlFromVirtual("$(parent)CombatDps", self.control.infoArea, "GDLabel15")
	self.control.infoArea.combatDps:SetAnchor(BOTTOMRIGHT, self.control.infoArea, BOTTOMRIGHT, -2, 0)
	self.control.infoArea.combatDuration = WM:CreateControlFromVirtual("$(parent)CombatDuration", self.control.infoArea, "GDLabel20")
	self.control.infoArea.combatDuration:SetAnchor(TOP, self.control.infoArea, TOP, 0, -2)
	
	--Missing group members
	self.control.missingGroup = WM:CreateControl("$(parent)MissingGroup", self.control, CT_CONTROL) 
	self.control.missingGroup:SetAnchor(BOTTOMLEFT, self.control, TOPLEFT, 0, 0)
	self.control.missingGroup:SetHeight(25)
	self.control.missingGroup:SetWidth(200)
	self.control.missingGroup.bg = WM:CreateControlFromVirtual("$(parent)Bg", self.control.missingGroup, "GDBackdropFill")	
	self.control.missingGroup.text = WM:CreateControlFromVirtual("$(parent)Text", self.control.missingGroup, "GDLabel16")
	self.control.missingGroup.text:SetAnchorFill()
	self.control.missingGroup.text:SetColor(0.8,0.2,0,1)
	self.control.missingGroup.text:SetText("Unknown from group: 12/12")
	
	self.control.missingGroup.button = WM:CreateControlFromVirtual("$(parent)Button", self.control.missingGroup, "GDPanelButton")
	self.control.missingGroup.button:SetAnchorFill()
	self.control.missingGroup.button:SetHandler("OnClicked", function() self:ToggleMissingGroup() end)
	
	self.control.missingGroup.labels = {}
	for i=1, 12 do
		self.control.missingGroup.labels[i] = WM:CreateControlFromVirtual("$(parent)Label"..i, self.control.missingGroup, "GDLabel16")
		self.control.missingGroup.labels[i]:SetAnchor(BOTTOMLEFT, self.control.missingGroup.labels[i-1], TOPLEFT, 0, 0)
		if i == 1 then
			self.control.missingGroup.labels[i]:ClearAnchors()		
			self.control.missingGroup.labels[i]:SetAnchor(BOTTOMLEFT, self.control.missingGroup, TOPLEFT, 0, 0)
		end		
		self.control.missingGroup.labels[i]:SetHeight(20)
		self.control.missingGroup.labels[i]:SetColor(0.8,0.2,0,1)
	end
	
	--Buttons
	self.control.buttonClose = WM:CreateControl("$(parent)ButtonClose", self.control, CT_CONTROL)
	self.control.buttonClose:SetAnchor(RIGHT, self.control, RIGHT, -1, 0)
	self.control.buttonClose:SetWidth(23)
	self.control.buttonClose:SetHeight(23)
	self.control.buttonClose.button = WM:CreateControlFromVirtual("$(parent)Button", self.control.buttonClose, "GDPanelButton")
	self.control.buttonClose.button:SetText("X")
	self.control.buttonClose.button:SetMouseOverFontColor(1, 0, 0, 1) 
	self.control.buttonClose.button:SetNormalFontColor(1, 1, 1, 1) 
	self.control.buttonClose.button:SetHandler("OnClicked", function() self:HidePanel(true) end)
	self.control.buttonClose.bg = WM:CreateControlFromVirtual("$(parent)Bg", self.control.buttonClose, "GDPanelButtonBg")	

	self.control.buttonClear = WM:CreateControl("$(parent)buttonClear", self.control, CT_CONTROL)
	self.control.buttonClear:SetAnchor(RIGHT, self.control.buttonClose, LEFT, -1, 0)
	self.control.buttonClear:SetWidth(23)
	self.control.buttonClear:SetHeight(23)
	self.control.buttonClear.button = WM:CreateControlFromVirtual("$(parent)Button", self.control.buttonClear, "GDPanelButton")
	self.control.buttonClear.button:SetText("C")
	self.control.buttonClear.button:SetMouseOverFontColor(1, 0.25, 0, 1) 
	self.control.buttonClear.button:SetNormalFontColor(1, 1, 1, 1) 
	self.control.buttonClear.button:SetHandler("OnClicked", function() self:ClearHistoryFight() end)
	self.control.buttonClear.bg = WM:CreateControlFromVirtual("$(parent)Bg", self.control.buttonClear, "GDPanelButtonBg")						
						
	self.control.buttonType = WM:CreateControl("$(parent)buttonType", self.control, CT_CONTROL)
	self.control.buttonType:SetAnchor(RIGHT, self.control.buttonClear, LEFT, -5, 0)
	self.control.buttonType:SetWidth(23)
	self.control.buttonType:SetHeight(23)
	self.control.buttonType.button = WM:CreateControlFromVirtual("$(parent)Button", self.control.buttonType, "GDPanelButton")
	self.control.buttonType.button:SetHandler("OnClicked", function() self:ChangeUnitTypeShown("") end)
	self.control.buttonType.bg = WM:CreateControlFromVirtual("$(parent)Bg", self.control.buttonType, "GDPanelButtonBg")					
						
	self.control.buttonDmgHeal = WM:CreateControl("$(parent)buttonDmgHeal", self.control, CT_CONTROL)
	self.control.buttonDmgHeal:SetAnchor(RIGHT, self.control.buttonType, LEFT, -1, 0)
	self.control.buttonDmgHeal:SetWidth(23)
	self.control.buttonDmgHeal:SetHeight(23)
	self.control.buttonDmgHeal.button = WM:CreateControlFromVirtual("$(parent)Button", self.control.buttonDmgHeal, "GDPanelButton")
	self.control.buttonDmgHeal.button:SetHandler("OnClicked", function() self:ChangeDisplayMode() end)
	self.control.buttonDmgHeal.bg = WM:CreateControlFromVirtual("$(parent)Bg", self.control.buttonDmgHeal, "GDPanelButtonBg")	

	self.control.buttonNext = WM:CreateControl("$(parent)buttonNext", self.control, CT_CONTROL)
	self.control.buttonNext:SetAnchor(RIGHT, self.control.buttonDmgHeal, LEFT, -1, 0)
	self.control.buttonNext:SetWidth(23)
	self.control.buttonNext:SetHeight(23)
	self.control.buttonNext.button = WM:CreateControlFromVirtual("$(parent)Button", self.control.buttonNext, "GDPanelButton")
	self.control.buttonNext.button:SetText(">")
	self.control.buttonNext.button:SetHandler("OnClicked", function() self:ChangeShownFight("next") end)
	self.control.buttonNext.bg = WM:CreateControlFromVirtual("$(parent)Bg", self.control.buttonNext, "GDPanelButtonBg")

	self.control.buttonPrev = WM:CreateControl("$(parent)buttonPrev", self.control, CT_CONTROL)
	self.control.buttonPrev:SetAnchor(RIGHT, self.control.buttonNext, LEFT, -1, 0)
	self.control.buttonPrev:SetWidth(23)
	self.control.buttonPrev:SetHeight(23)
	self.control.buttonPrev.button = WM:CreateControlFromVirtual("$(parent)Button", self.control.buttonPrev, "GDPanelButton")
	self.control.buttonPrev.button:SetText("<")
	self.control.buttonPrev.button:SetHandler("OnClicked", function() self:ChangeShownFight("prev") end)
	self.control.buttonPrev.bg = WM:CreateControlFromVirtual("$(parent)Bg", self.control.buttonPrev, "GDPanelButtonBg")
	
	self.control.buttonInf = WM:CreateControl("$(parent)buttonInf", self.control, CT_CONTROL)
	self.control.buttonInf:SetAnchor(RIGHT, self.control.buttonPrev, LEFT, -1, 0)
	self.control.buttonInf:SetWidth(23)
	self.control.buttonInf:SetHeight(23)
	self.control.buttonInf.button = WM:CreateControlFromVirtual("$(parent)Button", self.control.buttonInf, "GDPanelButton")
	self.control.buttonInf.button:SetText("*")
	self.control.buttonInf.button:SetFont("$(BOLD_FONT)|26|soft-shadow-thin")
	self.control.buttonInf.button:SetHandler("OnClicked", function() self:ToggleInfMode() end)
	self.control.buttonInf.bg = WM:CreateControlFromVirtual("$(parent)Bg", self.control.buttonInf, "GDPanelButtonBg")
	if self.svars.infinityMode then
		self.control.buttonInf.button:SetNormalFontColor(0.8,0.2,1,1)
		self.control.buttonInf.button:SetMouseOverFontColor(0.8,0.2,1,0.6)
	end	

	
	if self.svars.statsActive then
		self.control.statsButton = WM:CreateControl("$(parent)StatsButton", self.control, CT_CONTROL)
		self.control.statsButton:SetAnchor(BOTTOMRIGHT, self.control, TOPRIGHT, 0, 0)
		self.control.statsButton:SetWidth(50)
		self.control.statsButton:SetHeight(25)
		self.control.statsButton.button = WM:CreateControlFromVirtual("$(parent)Button", self.control.statsButton, "GDPanelButton")
		self.control.statsButton.button:SetText("STATS")
		self.control.statsButton.button:SetFont("ZoFontGame")
		self.control.statsButton.button:SetHandler("OnClicked", function() GroupDamageStats:HidePanel(false) end)
		self.control.statsButton.bg = WM:CreateControlFromVirtual("$(parent)Bg", self.control.statsButton, "GDPanelButtonBg")
	end
	
	self:ChangeBarSettings(self.svars.numberBarsShown)	
end

function GroupDamage:ChangeBarSettings(numberBars)		
	self.svars.numberBarsShown = numberBars
	for i=1, 12 do
		if i <= numberBars then
			self.control.barArea.bars[i]:SetHidden(false)
		else
			self.control.barArea.bars[i]:SetHidden(true)
		end
	end
	self.control.barArea:SetHeight(numberBars*20)
	self:ResetPanelControls()
end
function GroupDamage:ResetPanelControls()
	for i=1, 12 do	
		self.control.barArea.bars[i].statusBar:SetValue(0)
		self.control.barArea.bars[i].name:SetText("")
		self.control.barArea.bars[i].value:SetText("")
		if i%2==0 then
			self.control.barArea.bars[i].statusBar:SetColor(self.svars.panelBarsColor[1], self.svars.panelBarsColor[2], self.svars.panelBarsColor[3], self.svars.panelBarsColor[4])				
			self.control.barArea.bars[i].bg:SetCenterColor(self.svars.panelBgColor[1]*1.05, self.svars.panelBgColor[2]*1.05, self.svars.panelBgColor[3]*1.05, self.svars.panelBgColor[4])	
		else
			self.control.barArea.bars[i].statusBar:SetColor(self.svars.panelBarsColor2[1], self.svars.panelBarsColor2[2], self.svars.panelBarsColor2[3], self.svars.panelBarsColor2[4])		
			self.control.barArea.bars[i].bg:SetCenterColor(self.svars.panelBgColor[1]*0.95, self.svars.panelBgColor[2]*0.95, self.svars.panelBgColor[3]*0.95, self.svars.panelBgColor[4])
		end	
	end	
	self.control.infoArea.combatDuration:SetText("0:00")
	self.control.infoArea.combatTarget:SetText("")
	self.control.infoArea.combatDmg:SetText("dmg: 0")
	self.control.infoArea.combatDps:SetText("dps: 0")
	
	self.control.missingGroup.bg:SetCenterColor(self.svars.panelBgColor[1], self.svars.panelBgColor[2], self.svars.panelBgColor[3], self.svars.panelBgColor[4])
	
	self:UpdatePanel()
end
function GroupDamage:HidePanel(boolTrue)
	if boolTrue then
		self.hudScene:RemoveFragment(self.panelFragment)
		self.hudUiScene:RemoveFragment(self.panelFragment)
	else
		self.hudScene:AddFragment(self.panelFragment)
		self.hudUiScene:AddFragment(self.panelFragment)
	end
end
function GroupDamage:ToggleMissingGroup()
	self.missingGrpVisibile = not self.missingGrpVisibile
	self:UpdateMissingGroupMembers()
end
function GroupDamage:OnDisplayPosChange()
	self.svars.offset["x"] = self.control:GetLeft()
	self.svars.offset["y"] = self.control:GetTop()
end