local selectedTarget = -1

function GroupDamageStats:CreateCombatList()
	self:ResetSources()
	self:ResetList()
	
	self.control.list.items[1].button:SetText("Current Fight")
	self.control.list.items[1].button:SetHandler("OnClicked", function() self:SetFightTo(-1) end)
	--TODO: history
end

function GroupDamageStats:SetFightTo(fightId)
	
	self:MakeStatsForFight(fightId)
	
	if self.currentStats["mainTarget"] == "" then return end
	
	self:CreateTargetList()
	self:CreateSourceListForTarget(-1)
	local combatIdString = "Current Fight"
	if fightId ~= -1 then
		--TODO
	end
	self.control.combatInfo.label:SetText(combatIdString .. " against " .. self.currentStats["mainTarget"] .. ", lasted " .. self.currentStats["duration"] .. "ms")
end


function GroupDamageStats:CreateTargetList()
	self:ResetList()
	self.control.list.items[1].button:SetText("<ALL TARGETS>")	
	self.control.list.items[1].button:SetHandler("OnClicked", function() self:CreateSourceListForTarget(-1,1) end)
	for i=1, #self.currentStats["targetRankingDmg"] do
		if i > 9 then break end
		self.control.list.items[i+1].button:SetText(self.currentStats["targetRankingDmg"][i]["name"])	
		self.control.list.items[i+1].button:SetHandler("OnClicked", function() self:CreateSourceListForTarget(self.currentStats["targetRankingDmg"][i]["id"],i+1) end)
	end			
end
function GroupDamageStats:CreateSourceListForTarget(targetId, buttonId)
	self:ResetSources()
	selectedTarget = targetId
	if targetId == -1 then
		for i=1, #self.currentStats["rankingDmg"] do
			if self.control.body.ranking.rank[i] == nil then break end
			self.control.body.ranking.rank[i].number:SetText(i)
			self.control.body.ranking.rank[i].name:SetText(self.currentStats["rankingDmg"][i]["name"])
			self.control.body.ranking.rank[i].value:SetText(self.currentStats["rankingDmg"][i]["dmg"])
			self.control.body.ranking.rank[i].perSec:SetText(self.currentStats["rankingDmg"][i]["dps"])
			self.control.body.ranking.rank[i].button:SetHandler("OnClicked", function() self:ShowAbilityDetails(selectedTarget, self.currentStats["rankingDmg"][i]["id"]) end)
		end
		self:ResetList()
		self:CreateTargetList()
		self.control.list.items[1].button:SetMouseOverFontColor(1, 1, 0, 1) 
		self.control.list.items[1].button:SetNormalFontColor(1, 1, 0, 1) 
		
	else
		if self.currentStats["units"][targetId] ~= nil then	--REMOVE IF UNITS GET FILLED 100%
			for i=1, #self.currentStats["units"][targetId]["dmgRecievedFrom"] do
				if self.control.body.ranking.rank[i] == nil then break end
				self.control.body.ranking.rank[i].number:SetText(i)
				self.control.body.ranking.rank[i].name:SetText(self.currentStats["units"][targetId]["dmgRecievedFrom"][i]["name"])
				self.control.body.ranking.rank[i].value:SetText(self.currentStats["units"][targetId]["dmgRecievedFrom"][i]["dmg"])
				self.control.body.ranking.rank[i].perSec:SetText(self.currentStats["units"][targetId]["dmgRecievedFrom"][i]["dps"])
				self.control.body.ranking.rank[i].button:SetHandler("OnClicked", function() self:ShowAbilityDetails(selectedTarget, self.currentStats["units"][targetId]["dmgRecievedFrom"][i]["id"]) end)
			end
			self:ResetList()
			self:CreateTargetList()
			self.control.list.items[buttonId].button:SetMouseOverFontColor(1, 1, 0, 1) 
			self.control.list.items[buttonId].button:SetNormalFontColor(1, 1, 0, 1) 
		else
			--NO DMG TAKEN/empty unit		
		end
	end
end
function GroupDamageStats:ShowAbilityDetails(target, unit)
	self.control.buttonDebug.button:SetHandler("OnClicked", function() self:DebugOutput(self.currentStats["units"][unit]["abilityTargetsDmg"][target], "ability") end)
	self:ResetSources()
	if target == -1 then
		for i=1, #self.currentStats["units"][unit]["abilityOverallDmg"] do
			if self.control.body.ranking.rank[i] == nil then break end
			self.control.body.ranking.rank[i].number:SetText(i)
			self.control.body.ranking.rank[i].name:SetText(GetAbilityName(self.currentStats["units"][unit]["abilityOverallDmg"][i]["id"]))
			self.control.body.ranking.rank[i].value:SetText(self.currentStats["units"][unit]["abilityOverallDmg"][i]["value"])
			self.control.body.ranking.rank[i].perSec:SetText(("%01.00f"):format(self.currentStats["units"][unit]["abilityOverallDmg"][i]["dps"]))
			self.control.body.ranking.rank[i].crit:SetText(("%03.01f%%"):format(self.currentStats["units"][unit]["abilityOverallDmg"][i]["crits"]/(self.currentStats["units"][unit]["abilityOverallDmg"][i]["hits"]+self.currentStats["units"][unit]["abilityOverallDmg"][i]["crits"])*100))
			self.control.body.ranking.rank[i].count:SetText(self.currentStats["units"][unit]["abilityOverallDmg"][i]["hits"]+self.currentStats["units"][unit]["abilityOverallDmg"][i]["crits"])
			self.control.body.ranking.rank[i].button:SetHandler("OnClicked", function() end)
		end
	else
		for i=1, #self.currentStats["units"][unit]["abilityTargetsDmg"][target] do
			if self.control.body.ranking.rank[i] == nil then break end
			self.control.body.ranking.rank[i].number:SetText(i)
			self.control.body.ranking.rank[i].name:SetText(GetAbilityName(self.currentStats["units"][unit]["abilityTargetsDmg"][target][i]["id"]))
			self.control.body.ranking.rank[i].value:SetText(self.currentStats["units"][unit]["abilityTargetsDmg"][target][i]["value"])
			self.control.body.ranking.rank[i].perSec:SetText(("%01.00f"):format(self.currentStats["units"][unit]["abilityTargetsDmg"][target][i]["dps"]))
			self.control.body.ranking.rank[i].crit:SetText(("%03.01f%%"):format(self.currentStats["units"][unit]["abilityTargetsDmg"][target][i]["crits"]/(self.currentStats["units"][unit]["abilityTargetsDmg"][target][i]["hits"]+self.currentStats["units"][unit]["abilityTargetsDmg"][target][i]["crits"])*100))
			self.control.body.ranking.rank[i].count:SetText(self.currentStats["units"][unit]["abilityTargetsDmg"][target][i]["hits"]+self.currentStats["units"][unit]["abilityTargetsDmg"][target][i]["crits"])
			self.control.body.ranking.rank[i].button:SetHandler("OnClicked", function() end)
		end
	end
end


function GroupDamageStats:MakeStatsForFight(fightId)
	local fightArray = nil
	
	if fightId == -1 then
		fightArray = GroupDamage.currentFightData
	else
		fightArray = GroupDamage.combatHistory[fightId]
	end	
	
	self.currentStats = nil
	self.currentStats		= {
	["duration"]			= 0,
	["mainTarget"]			= "",
	["rankingDmg"]			= {},
	["targetRankingDmg"]	= {},
	["rankingHeal"]			= {},
	["targetRankingHeal"]	= {},
	["units"]				= {},
}
	
	self:CreateUnitArrays(fightArray)
	self:CopyData(fightArray)
	
	self:SortTargetRanking(fightArray)	
	self:MakePerUnitRankings(fightArray)
	self:MakeAbilityStats(fightArray)
end

function GroupDamageStats:CreateUnitArrays(fightArray)
	for unit, data in pairs(fightArray["units"]) do
		self.currentStats["units"][unit] = {
			["name"] = data["name"],
			["player"] = data["player"],
			["group"] = data["group"],
			["interactPlayer"] = false,
			["interactGroup"] = false,
			["dmg"] = data["dmg"],
			["dps"] = data["dps"],
			["abilityOverallDmg"] = {},
			["abilityTargetsDmg"] = {},			
			["heal"] = data["heal"],
			["hps"] = data["hps"],
			["abilityOverallHeal"] = {},
			["abilityTargetsHeal"] = {},
			["dmgRecievedFrom"] = {},
			["healRecievedFrom"] = {},			
		}
	end
end
function GroupDamageStats:CopyData(fightArray)
	self.currentStats["rankingDmg"] = nil
	self.currentStats["rankingDmg"] = {}
	for i=1, #fightArray["ranking"] do
		self.currentStats["rankingDmg"][i] = {["id"]=fightArray["ranking"][i]["id"], ["name"]=fightArray["ranking"][i]["name"], ["dmg"]=fightArray["ranking"][i]["dmg"], ["dps"]=fightArray["ranking"][i]["dps"], ["player"]=fightArray["ranking"][i]["player"], ["group"]=fightArray["ranking"][i]["group"]}
	end
	self.currentStats["rankingHeal"] = nil
	self.currentStats["rankingHeal"] = {}
	for i=1, #fightArray["rankingHeal"] do
		self.currentStats["rankingHeal"][i] = {["id"]=fightArray["rankingHeal"][i]["id"], ["name"]=fightArray["rankingHeal"][i]["name"], ["dmg"]=fightArray["rankingHeal"][i]["dmg"], ["dps"]=fightArray["rankingHeal"][i]["dps"], ["player"]=fightArray["rankingHeal"][i]["player"], ["group"]=fightArray["rankingHeal"][i]["group"]}
	end
	
	self.currentStats["mainTarget"] 		= fightArray["mainTarget"]["name"]
	
	self.currentStats["combatStart"] 		= fightArray["combatStart"]
	self.currentStats["combatStartClock"]	= fightArray["combatStartClock"]
	self.currentStats["combatEnd"] 			= fightArray["combatEnd"] 	
	self.currentStats["combatEndClock"] 	= fightArray["combatEndClock"]
	self.currentStats["duration"] 			= fightArray["combatTime"]
	
end

function GroupDamageStats:SortTargetRanking(fightArray)
	local sortValue = "dmgRecieved"
	self.currentStats["targetRankingDmg"] = nil
	self.currentStats["targetRankingDmg"] = {}
	for k,v in pairs(fightArray["units"]) do
		table.insert(self.currentStats["targetRankingDmg"], {["name"]=v["name"], ["player"]=v["player"], ["group"]=v["group"], ["id"] = k, [sortValue]=v[sortValue]} )
	end
	self:SortRanking(self.currentStats["targetRankingDmg"], sortValue)
	
	sortValue = "healRecieved"
	self.currentStats["targetRankingHeal"] = nil
	self.currentStats["targetRankingHeal"] = {}
	for k,v in pairs(fightArray["units"]) do
		table.insert(self.currentStats["targetRankingHeal"], {["name"]=v["name"], ["player"]=v["player"], ["group"]=v["group"], ["id"] = k, [sortValue]=v[sortValue]} )
	end
	self:SortRanking(self.currentStats["targetRankingHeal"], sortValue)
end
function GroupDamageStats:MakePerUnitRankings(fightArray)
	local dataDumpArray = {}
	for unitId, unitArray in pairs(fightArray["units"]) do
		for targetId, abilities in pairs(unitArray["dmgData"]) do
			if dataDumpArray[targetId] == nil then dataDumpArray[targetId] = {} end
			for abilityId, values in pairs(abilities) do			
				if dataDumpArray[targetId][unitId] == nil then dataDumpArray[targetId][unitId] = 0 end
				dataDumpArray[targetId][unitId] = dataDumpArray[targetId][unitId] + values["value"]
			end
		end
	end	
	for target, units in pairs(dataDumpArray) do
		--if self.currentStats["units"][target] == nil then self.currentStats["units"][target] = {} end
		--if self.currentStats["units"][target]["dmgRecievedFrom"] == nil then self.currentStats["units"][target]["dmgRecievedFrom"] = {} end
		for unit, dmgDone in pairs(units) do
			table.insert(self.currentStats["units"][target]["dmgRecievedFrom"], {["id"]=unit, ["dmg"]=dmgDone, ["dps"]=(dmgDone/self.currentStats["duration"])*1000, ["name"]=fightArray["units"][unit]["name"]} )
		end
		self:SortRanking(self.currentStats["units"][target]["dmgRecievedFrom"], "dmg")
	end
	
	dataDumpArray = nil
	dataDumpArray = {}
	for unitId, unitArray in pairs(fightArray["units"]) do
		for targetId, abilities in pairs(unitArray["healData"]) do
			if dataDumpArray[targetId] == nil then dataDumpArray[targetId] = {} end
			for abilityId, values in pairs(abilities) do			
				if dataDumpArray[targetId][unitId] == nil then dataDumpArray[targetId][unitId] = 0 end
				dataDumpArray[targetId][unitId] = dataDumpArray[targetId][unitId] + values["value"]
			end
		end
	end
	for target, units in pairs(dataDumpArray) do
		--if self.currentStats["units"][target] == nil then self.currentStats["units"][target] = {} end
		--if self.currentStats["units"][target]["healRecievedFrom"] == nil then self.currentStats["units"][target]["healRecievedFrom"] = {} end
		for unit, healDone in pairs(units) do
			table.insert(self.currentStats["units"][target]["healRecievedFrom"], {["id"]=unit, ["heal"]=healDone, ["hps"]=(healDone/self.currentStats["duration"])*1000, ["name"]=fightArray["units"][unit]["name"]} )
		end
		self:SortRanking(self.currentStats["units"][target]["healRecievedFrom"], "heal")
	end	
end

function GroupDamageStats:MakeAbilityStats(fightArray)
	local dataDumpArray = {}
	local dataUsed = "dmgData"
	
	for unit, data in pairs(fightArray["units"]) do
		if dataDumpArray[unit] == nil then dataDumpArray[unit] = {["abilityOverallDmg"]={}, ["abilityTargetsDmg"]={}} end
		for target, abilities in pairs(data[dataUsed]) do
			if dataDumpArray[unit]["abilityTargetsDmg"][target] == nil then dataDumpArray[unit]["abilityTargetsDmg"][target] = {} end
			for ability, values in pairs(abilities) do
				if dataDumpArray[unit]["abilityTargetsDmg"][target][ability] == nil then
					dataDumpArray[unit]["abilityTargetsDmg"][target][ability] = {["value"] = values["value"], ["hits"] = values["hits"], ["crits"] = values["crits"], ["dps"] = (values["value"]/self.currentStats["duration"])*1000}
				end
				if dataDumpArray[unit]["abilityOverallDmg"][ability] == nil then
					dataDumpArray[unit]["abilityOverallDmg"][ability] = {["value"] = 0, ["hits"] = 0, ["crits"] = 0, ["dps"] = 0}
				end
				dataDumpArray[unit]["abilityOverallDmg"][ability]["value"] = dataDumpArray[unit]["abilityOverallDmg"][ability]["value"] + values["value"]
				dataDumpArray[unit]["abilityOverallDmg"][ability]["hits"] = dataDumpArray[unit]["abilityOverallDmg"][ability]["hits"] + values["hits"]
				dataDumpArray[unit]["abilityOverallDmg"][ability]["crits"] = dataDumpArray[unit]["abilityOverallDmg"][ability]["crits"] + values["crits"]				
			end
		end
		
		for ability, v in pairs(dataDumpArray[unit]["abilityOverallDmg"]) do
			v["dps"] = (v["value"]/self.currentStats["duration"])*1000	
		end
	end	
	
	for unit, data in pairs(dataDumpArray) do
		--overall for unit
		for ability, v in pairs(dataDumpArray[unit]["abilityOverallDmg"]) do
			table.insert(self.currentStats["units"][unit]["abilityOverallDmg"], {["id"]=ability, ["value"]=v["value"], ["hits"]=v["hits"], ["crits"]=v["crits"], ["dps"]=v["dps"]})
		end
		self:SortRanking(self.currentStats["units"][unit]["abilityOverallDmg"], "value")	
		--per target for unit
		for target, abilities in pairs(dataDumpArray[unit]["abilityTargetsDmg"]) do
			self.currentStats["units"][unit]["abilityTargetsDmg"][target] = {}
			for ability, v in pairs(abilities) do
				table.insert(self.currentStats["units"][unit]["abilityTargetsDmg"][target], {["id"]=ability, ["value"]=v["value"], ["hits"]=v["hits"], ["crits"]=v["crits"], ["dps"]=v["dps"]})
			end	
			self:SortRanking(self.currentStats["units"][unit]["abilityTargetsDmg"][target], "value")				
		end
	end
end

--sort sortValue descending in an array like ...,[k] = {...,[sortValue]=x,...},...
function GroupDamageStats:SortRanking(rankingArray, sortValue)
	for rank=1, #rankingArray do
		local currentItem = rankingArray[rank]
		local biggerItem = rank
		
		for k=rank+1, #rankingArray do
			if rankingArray[k][sortValue] > rankingArray[biggerItem][sortValue] then 
				biggerItem = k
			end
		end
			
		rankingArray[rank] = rankingArray[biggerItem]
		rankingArray[biggerItem] = currentItem
	end
end






function GroupDamageStats:DebugOutput(tableVar, aType)
	if aType == "ability" then
		for i=1, #tableVar do
			d("#"..i..": "..tableVar[i]["id"].." = "..GetAbilityName(tableVar[i]["id"]).." > "..tableVar[i]["value"])			
		end
	end
end

-- --this is just some random unused crap atm

		-- ["activeTime"] 		= 0,
		-- ["deaths"]			= 0,

-- local activeTimeMaxDelay = 5000 --in ms

-- if hit.timeMs - self.currentFightData["units"][hit.sourceId]["lastAction"] <= activeTimeMaxDelay then
		-- self.currentFightData["units"][hit.sourceId]["activeTime"] = self.currentFightData["units"][hit.sourceId]["activeTime"] + hit.timeMs - self.currentFightData["units"][hit.sourceId]["lastAction"]
	-- end
	-- self.currentFightData["units"][hit.sourceId]["lastAction"] = hit.timeMs	
	
		
-- function GroupDamage.isWeaponAttack(abilityId)
    -- local attacks = {
        -- 4858,      -- Bash
        -- 7880,      -- Light Attack
        -- 7095,      -- Heavy Attack
        -- 16420,     -- Heavy Attack (Dual Wield)
        -- 16691,     -- Heavy Attack (Bow)
        -- 32480,     -- Heavy Attack Werewolf
    -- }
    -- for i = 1, #attacks do
        -- if abilityId == attacks[i] then return true end 
    -- end
	-- return false
-- end