function GroupDamage.settingsUpdate()
	for i=1, 12 do	
		GroupDamage.control.barArea.bars[i].statusBar:SetValue(100-7*i)
		GroupDamage.control.barArea.bars[i].name:SetText("Example Name #" .. i)
		GroupDamage.control.barArea.bars[i].value:SetText(2000000-150000*i .. " (" .. 50000-3300*i .. ") " ..  100-7*i .. "%")
	end
end
local oldPosition = {}
function GroupDamage.optionsShow()
	local menuScene	= SCENE_MANAGER:GetScene("gameMenuInGame")
	menuScene:AddFragment(GroupDamage.panelFragment)
	oldPosition = {GroupDamage.control:GetLeft(), GroupDamage.control:GetTop()}
	GroupDamage.control:ClearAnchors()
	GroupDamage.control:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, 1300, 400)
	GroupDamage.control:SetMovable(false)
	GroupDamage.control:SetMouseEnabled(false)
	
	GroupDamage.control.buttonDmgHeal.button:SetEnabled(false) 
	GroupDamage.control.buttonInf.button:SetEnabled(false) 
	--GroupDamage.control.buttonType.button:SetEnabled(false) 
	GroupDamage.control.buttonPrev.button:SetEnabled(false) 
	GroupDamage.control.buttonNext.button:SetEnabled(false) 
	GroupDamage.control.buttonClear.button:SetEnabled(false) 
	GroupDamage.control.buttonClose.button:SetEnabled(false) 
	GroupDamage.control:SetHandler("OnUpdate", function() GroupDamage.settingsUpdate() end)
end
function GroupDamage.optionsHide()
	local menuScene	= SCENE_MANAGER:GetScene("gameMenuInGame")
	menuScene:RemoveFragment(GroupDamage.panelFragment)
	GroupDamage.control:ClearAnchors()
	GroupDamage.control:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, oldPosition[1], oldPosition[2])
	GroupDamage.control:SetMovable(true)
	GroupDamage.control:SetMouseEnabled(true)
	
	GroupDamage.control.buttonDmgHeal.button:SetEnabled(true) 
	GroupDamage.control.buttonInf.button:SetEnabled(true) 
	--GroupDamage.control.buttonType.button:SetEnabled(true) 
	GroupDamage.control.buttonPrev.button:SetEnabled(true) 
	GroupDamage.control.buttonNext.button:SetEnabled(true) 
	GroupDamage.control.buttonClear.button:SetEnabled(true) 
	GroupDamage.control.buttonClose.button:SetEnabled(true) 
	GroupDamage.control:SetHandler("OnUpdate", function() GroupDamage.updateHandler() end)
	GroupDamage:ResetPanelControls()
end

function GroupDamage:SetupAddonMenu()
	
	self.LAM = LibStub("LibAddonMenu-2.0")
	
	local panelData = {
        type = "panel",
        name = self.name,
        displayName = ZO_ColorDef:New("E6B85C"):Colorize(self.name),
        author = "coolmodi",
        version = self.version,
        registerForRefresh = true,
        registerForDefaults = true,
		resetFunc = function() 
			self.savedVariablesAw.accountWide			= true
			
			self.savedVariablesAw.unitTypeToShow		= "all"
			self.savedVariablesAw.displayMode			= "dmg"
			self.savedVariablesAw.numberBarsShown 		= 4
			self.savedVariablesAw.infinityMode			= false
			self.savedVariablesAw.panelBgColor 			= {0.2823529541, 0.3960784376, 0.4784313738, 0.7537196279}
			self.savedVariablesAw.panelHeaderColor 		= {0.5921568871, 0.7882353067, 0.9098039269, 0.6268595457}
			self.savedVariablesAw.panelBarsColor		= {0.4039215744, 0.6117647290, 0.7176470757, 0.5507436991}
			self.savedVariablesAw.panelBarsColor2		= {0.2352941185, 0.4784313738, 0.6392157078, 0.5422863364}
			self.savedVariablesAw.offset				= {["x"] = 1450, ["y"] = 615}		
			self.savedVariablesAw.fightsToSave			= 100
			self.savedVariablesAw.minTimeForHist		= 0
			self.savedVariablesAw.showGroupCheck		= true
			self.savedVariablesAw.showOnCombatStart		= false
			self.savedVariablesAw.hideDuringCombat		= false
			self.savedVariablesAw.hideOnCombatEnd		= false
			self.savedVariablesAw.hideAfter				= 10				
			self.savedVariablesAw.statsActive			= false
			self.savedVariablesAw.statsOffset			={["x"] = 0, ["y"] = 0}
			
			self.savedVariablesChar.unitTypeToShow		= "all"
			self.savedVariablesChar.displayMode			= "dmg"
			self.savedVariablesChar.numberBarsShown 	= 4
			self.savedVariablesChar.infinityMode		= false
			self.savedVariablesChar.panelBgColor 		= {0.2823529541, 0.3960784376, 0.4784313738, 0.7537196279}
			self.savedVariablesChar.panelHeaderColor 	= {0.5921568871, 0.7882353067, 0.9098039269, 0.6268595457}
			self.savedVariablesChar.panelBarsColor		= {0.4039215744, 0.6117647290, 0.7176470757, 0.5507436991}
			self.savedVariablesChar.panelBarsColor2		= {0.2352941185, 0.4784313738, 0.6392157078, 0.5422863364}
			self.savedVariablesChar.offset				= {["x"] = 1450, ["y"] = 615}			
			self.savedVariablesChar.fightsToSave		= 100
			self.savedVariablesChar.minTimeForHist		= 0
			self.savedVariablesChar.showGroupCheck		= true
			self.savedVariablesChar.showOnCombatStart	= false
			self.savedVariablesChar.hideDuringCombat	= false
			self.savedVariablesChar.hideOnCombatEnd		= false
			self.savedVariablesChar.hideAfter			= 10		
			self.savedVariablesChar.statsActive			= false
			self.savedVariablesChar.statsOffset			={["x"] = 0, ["y"] = 0}
			
			ReloadUI()
		end
    }
	
	self.LAM:RegisterAddonPanel("GroupDamagePanel", panelData)
	GroupDamagePanel:SetHandler( "OnEffectivelyShown", GroupDamage.optionsShow )
    GroupDamagePanel:SetHandler( "OnEffectivelyHidden", GroupDamage.optionsHide )
	
	local optionsTable = {		
		{
			type = "header",
			name = ZO_ColorDef:New("FFD175"):Colorize(GetString(SI_GROUPDAMAGE_MENU_MAINHEADER)),
		},
		{
			type = "checkbox",
			name = GetString(SI_GROUPDAMAGE_MENU_ACCWIDESETTINGS),
			getFunc = function() return self.savedVariablesAw.accountWide end,
			setFunc = function() self.savedVariablesAw.accountWide = not self.savedVariablesAw.accountWide ReloadUI() end,
			warning = GetString(SI_GROUPDAMAGE_MENU_RELOADWARN)
		},
		{
			type = "checkbox",
			name = GetString(SI_GROUPDAMAGE_MENU_INFMODE),
			tooltip = GetString(SI_GROUPDAMAGE_MENU_INFMODE_TT),
			getFunc = function() return self.svars.infinityMode end,
			setFunc = function() GroupDamage:ToggleInfMode() end
		},		
		{
			type = "dropdown",
			name = GetString(SI_GROUPDAMAGE_MENU_UNITTYPE),
			tooltip = GetString(SI_GROUPDAMAGE_MENU_UNITTYPE_TT),
			choices = {"all", "players", "group"},
			getFunc = function() return self.svars.unitTypeToShow end,
			setFunc = function(var) GroupDamage:ChangeUnitTypeShown(var) end
		},	
		{
			type = "slider",
			name = GetString(SI_GROUPDAMAGE_MENU_BARCOUNT),
			min = 2,
			max = 12,
			step = 1,
			getFunc = function() return self.svars.numberBarsShown end,
			setFunc = function(number) self:ChangeBarSettings(number) end,											
		},
		{
			type = "checkbox",
			name = GetString(SI_GROUPDAMAGE_MENU_GROUPCHECK),
			tooltip = GetString(SI_GROUPDAMAGE_MENU_GROUPCHECK_TT),
			getFunc = function() return self.svars.showGroupCheck end,
			setFunc = function() self.svars.showGroupCheck = not self.svars.showGroupCheck end
		},
	
		{
			type = "slider",
			name = GetString(SI_GROUPDAMAGE_MENU_FIGHTHISTORYSIZE),
			tooltip = GetString(SI_GROUPDAMAGE_MENU_FIGHTHISTORYSIZE_TT),
			min = 1,
			max = 500,
			step = 1,
			getFunc = function() return self.svars.fightsToSave end,
			setFunc = function(number) self.svars.fightsToSave = number end,
			width = "half",			
		},
		{
			type = "slider",
			name = GetString(SI_GROUPDAMAGE_MENU_MINTIMEFORHIST),
			tooltip = GetString(SI_GROUPDAMAGE_MENU_MINTIMEFORHIST_TT),
			min = 0,
			max = 60,
			step = 1,
			getFunc = function() return self.svars.minTimeForHist end,
			setFunc = function(number) self.svars.minTimeForHist = number end,
			width = "half",
		},
		{
			type = "checkbox",
			name = GetString(SI_GROUPDAMAGE_MENU_SHOWINCOMBAT),
			getFunc = function() return self.svars.showOnCombatStart end,
			setFunc = function() self.svars.showOnCombatStart = not self.svars.showOnCombatStart end,
			width = "half",
		},
		{
			type = "checkbox",
			name = GetString(SI_GROUPDAMAGE_MENU_HIDEDURINGCOMBAT),
			getFunc = function() return self.svars.hideDuringCombat end,
			setFunc = function() self.svars.hideDuringCombat = not self.svars.hideDuringCombat end,
			width = "half",
		},
		
		{
			type = "checkbox",
			name = GetString(SI_GROUPDAMAGE_MENU_HIDEAFTERCOMBAT),
			getFunc = function() return self.svars.hideOnCombatEnd end,
			setFunc = function() self.svars.hideOnCombatEnd = not self.svars.hideOnCombatEnd end,
			width = "half",
		},
		{
			type = "slider",
			name = GetString(SI_GROUPDAMAGE_MENU_HIDEDELAY),
			min = 0,
			max = 60,
			step = 1,
			getFunc = function() return self.svars.hideAfter end,
			setFunc = function(number) self.svars.hideAfter = number end,
			disabled = function() if not self.svars.hideOnCombatEnd then return true end end,
			width = "half",
		},
		
		
		
		{
			type = "header",
			name = ZO_ColorDef:New("FFD175"):Colorize(GetString(SI_GROUPDAMAGE_MENU_COLORHEADER)),
		},
		{
			type = "colorpicker",
			name = GetString(SI_GROUPDAMAGE_MENU_HEADERCOLOR),
			getFunc = function() return self.svars.panelHeaderColor[1], self.svars.panelHeaderColor[2], self.svars.panelHeaderColor[3], self.svars.panelHeaderColor[4] end,
			setFunc = function(r,g,b,a)
				self.svars.panelHeaderColor = {r,g,b,a}
				self.control.bg:SetCenterColor(self.svars.panelHeaderColor[1], self.svars.panelHeaderColor[2], self.svars.panelHeaderColor[3], self.svars.panelHeaderColor[4])	
				self.control.infoArea.bg:SetCenterColor(self.svars.panelHeaderColor[1], self.svars.panelHeaderColor[2], self.svars.panelHeaderColor[3], self.svars.panelHeaderColor[4])	
			end,
		},
		{
			type = "colorpicker",
			name = GetString(SI_GROUPDAMAGE_MENU_BGCOLOR),
			getFunc = function() return self.svars.panelBgColor[1], self.svars.panelBgColor[2], self.svars.panelBgColor[3], self.svars.panelBgColor[4] end,
			setFunc = function(r,g,b,a)
				self.svars.panelBgColor = {r,g,b,a}
				self:ResetPanelControls()
			end,
		},
		{
			type = "colorpicker",
			name = GetString(SI_GROUPDAMAGE_MENU_BARSCOLOR),
			getFunc = function() return self.svars.panelBarsColor[1], self.svars.panelBarsColor[2], self.svars.panelBarsColor[3], self.svars.panelBarsColor[4] end,
			setFunc = function(r,g,b,a)
				self.svars.panelBarsColor = {r,g,b,a}
				self:ResetPanelControls()
			end,
		},
		{
			type = "colorpicker",
			name = GetString(SI_GROUPDAMAGE_MENU_BARSCOLOR2),
			getFunc = function() return self.svars.panelBarsColor2[1], self.svars.panelBarsColor2[2], self.svars.panelBarsColor2[3], self.svars.panelBarsColor2[4] end,
			setFunc = function(r,g,b,a)
				self.svars.panelBarsColor2 = {r,g,b,a}
				self:ResetPanelControls()
			end,
		},
		{
			type = "header",
			name = ZO_ColorDef:New("FFD175"):Colorize("STATS"),
		},
		{
			type = "checkbox",
			name = "Activate super crappy alpha stats module",
			tooltip = "!! THIS IS JUST A VERY EARLY CONCEPT, YOU HAVE BEEN WARNED !!",
			getFunc = function() return self.svars.statsActive end,
			setFunc = function() self.svars.statsActive = not self.svars.statsActive ReloadUI() end
		},
		{
			type = "header",
			name = ZO_ColorDef:New("FFD175"):Colorize(GetString(SI_GROUPDAMAGE_MENU_GUIDEHEADER)),
		},
		{
			type = "texture",
			image = "GroupDamage/images/menu/menuPanelGuide.dds",
			imageHeight = 512,
			imageWidth = 512,
		},
		{
					type = "description",
					text = "* Infinity mode toggle\n < Previous fight\n > Next fight\n D Change between damage and heal\n A Change unit filter\n C Clear currently shown fight\n X Hide panel ",
		},
	}
	
	self.LAM:RegisterOptionControls("GroupDamagePanel", optionsTable)
end
